<?php
/*---------------------------------------------------------------*/
/*
    Titre : Conversion ISBN/EAN                                                                                           
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=619
    Auteur           : iwazaru                                                                                            
    Date dition     : 23 Dc 2010                                                                                        
    Date mise  jour : 01 Oct 2019
                                                                                       
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
    Date mise  jour : 22 Jan 2020
                                                                                       
    Rapport de la maj:                                                                                                    
    - correction du code                                                                                                  
*/
/*---------------------------------------------------------------*/

function isbn($x,$m = "check") {
        // ISBN Version 1.1 
        $x = str_replace(" ","",$x); // On retire les éventuels espaces
        $x = str_replace("-","",$x); 
// On retire les eventuels tirets (dans le cas d'un ISBN)
        if(strlen($x) == 10) $x = substr($x,0,9);
        elseif(strlen($x) == 13) $x = substr($x,0,12); 
// Si c'est un code à 10 ou 13 chiffres, on retire le dernier (cle de
// controle)
        if(strlen($x) == 12) { // Si c'est un code à 13 chiffres
            $A = substr($x,0,3); 
// On extrait le code produit (3 premiers chiffres)
            $x = substr($x,3,13); //  Et on le retire du code
            if($A != 978) return 
"Erreur : Le code produit ne correspond pas a un livre : ".$A;
        }
        if(empty($A)) $A = "978"; 
// Si le code produit n'est pas precise (ISBN10), on le crée
        if(is_numeric($x) and strlen($x) == 9) { 
// Si tout va bien, le code fait maintenant 9 chiffres
            
            $B = substr($x,0,1); // On extrait le code langue
            if($B == 2) { // Si le code langue est bien égal à 2 (francais)
                $CD = substr($x,1); 
// On extrait le code editeur (C) et le code livre (D)
                // Pour distinguer C et D, on récupère des extraits de C
                $CD1 = substr($CD,0,1);
                $CD3 = substr($CD,0,3);
                $CD4 = substr($CD,0,4);
                $CD5 = substr($CD,0,5);
                $CD6 = substr($CD,0,6);
                $CD7 = substr($CD,0,7);
                
// Et on compare ces plages de valeurs a ceux indiques dans
// http://isbn-international.org/agency?rmpdf=1&sort=agency
                // pour connaitre la taille de C
                if($CD1 == "0" or $CD1 == "1") $l = "2";
                elseif($CD3 >= "200" and $CD3 <= "349") $l = "3";
                elseif($CD5 >= "35000" and $CD5 <= "39999") $l = "5";
                elseif($CD3 >= "400" and $CD3 <= "699") $l = "3";
                elseif($CD4 >= "7000" and $CD4 <= "8399") $l = "4";
                elseif($CD5 >= "84000" and $CD5 <= "89999") $l = "5";
                elseif($CD6 >= "900000" and $CD6 <= "949999") $l = "6";
                elseif($CD7 >= "9500000" and $CD7 <= "9999999") $l = "7";
                // Enfin, on en deduit C et D
                $C = substr($CD,0,$l);
                $D = substr($CD,$l,8-$l);
            
                // Pour les ISBN-13 et EAN
                if($m == "EAN" or $m == "EAN13" or $m == "ISBN" or $m == 
"ISBN13") {
                    // Calcul de la cle (E) pour un ISBN-13
                    $k = $A.$B.$C.$D;
                    $k = str_split($k);
                    $i = 0; $i2 = 0; $r = 0; 
                    while($i2 <= 11)
                    {
                        if($i2%2 == 0) $p = "1";
                        else $p = "3";
                        if(!empty($k[$i])) {
                            $r += $k[$i] * $p;
                            if($k[$i] != "-") $i2++;
                        } else $i2++;
                        $i++;
                    }
                    $q = floor($r/10);
                    $E = 10 - ($r - $q * 10);
                    if($E == "10") $E = "0";
                    if($m == "EAN" or $m == "EAN13") return $A.$B.$C.$D.$E;
                    elseif($m == "ISBN" or $m == "ISBN13") return $A."-".$B."-".
$C."-".$D."-".$E;
                }
                
                // Pour les ISBN-10
                elseif($m == "ISBN10") {
                    $k = $B.$C.$D;
                    $k = str_split($k);
                    $m = 10; $t = 0;
                    foreach($k as $K) {
                        $K = $K*$m;
                        $t += $K;
                        $m--;
                    }
                    $E = 11 - ($t % 11);
                    if(strlen($E) > 1) $E = "X";
                    return $B."-".$C."-".$D."-".$E;
                }
                
                else return True;
            } else return "Erreur : Le code langue (".$B.") n'est pas français"
;
        } else return 
"Erreur : Le code n'a pas le bon nombre de chiffres ou autre chose que des" .
" chiffres";
    }
?>